<?php
/**
 * Plugin spxwslider
 *
 * @package SPX
 * @version	
 * @date	07/07/2014
 * @author	JE-EVRARD
 **/
class spxwresponsiveslides extends plxPlugin {
	
	
	/**
	 * Constructeur de la classe spxwslider
	 *
	 * @param	default_lang	langue par dfaut utilise par PluXml
	 * @return	null
	 * @author	
	 **/
	public function __construct($default_lang) {
		
		# Appel du constructeur de la classe plxPlugin (obligatoire)
		parent::__construct($default_lang);
		
		# droits pour accder  la page config.php du plugin
		$this->initconfiguration();
		$this->setConfigProfil(PROFIL_ADMIN);
		$this->spxname="spxwresponsiveslides";

		# Dclarations des hooks
		if(!defined('PLX_ADMIN')) {
			$this->addHook('ThemeEndHead', 'addLibrairy');
		}
		
		$this->addHook('spxwresponsiveslides::getResponsiveslidesID', 'getResponsiveslidesID');
		$this->addHook('spxwresponsiveslides::getResponsiveslidesTitle', 'getResponsiveslidesTitle');
	}

	public function initconfiguration() {
		# VARIOUS PARAMS
		$this->setParam('spxdatas_widget', '1', 'string');
		$this->setParam('spxshortcodes_shortcode', '1', 'string');
		
		
		if (plxUtils::strCheck($this->getParam('dataformat'))=="") $this->setParam('dataformat', 'xml', 'string');
		
		$aProfils = $this->get_aprofil();
		foreach($aProfils as $key=>$val) { 
			if (plxUtils::strCheck($this->getParam('profiladmin'.$key))=="") $this->setParam('profiladmin'.$key,$this->get_adminright_list(),'string');
			
		}
		foreach($aProfils as $key=>$val) { 
			if (plxUtils::strCheck($this->getParam('profiladmincontent'.$key))=="") $this->setParam('profiladmincontent'.$key,$this->get_adminrightcontent_list(),'string');
		}
		
	}
	
	/**
	 * Mthode qui ajoute les libs 
	 *
	 * @return	stdio
	 * @author	Evrard jerome
	 **/
	
	public function addLibrairy() {
		$this->addCssLibrairy();
		$this->addJSlibrairy();
	}
	
	/**
	 * Mthode qui ajoute le fichier css 
	 *
	 * @return	stdio
	 * @author	Evrard jerome
	 **/
	
	public function addCssLibrairy() {
		echo "\n".'
		<link href="'.PLX_PLUGINS.'/spxwresponsiveslides/css/slide.css" rel="stylesheet" type="text/css" />
		';
	
	}
	
	/**
	 * Mthode qui ajoute les lib et init
	 *
	 * @return	
	 * @author	Evrard jerome
	 **/
	public function addJSlibrairy() {
		
		echo "\n".'
		<script type="text/javascript">
		/* <![CDATA[ */
		!window.jQuery && document.write(\'<script  type="text/javascript" src="'.PLX_PLUGINS.'spxwresponsiveslides/assets/jquery-2.0.3.min.js"><\/script>\');
		/* !]]> */
		</script>

		<!-- Include required JS files -->
		<script type="text/javascript" src="'.PLX_PLUGINS.'/spxwresponsiveslides/assets/responsiveslides/responsiveslides.min.js"></script>
 		
		
		';
	}
	
	/**
	 * Mthode qui retourne les profils utilisateurs
	 *
	 * @return	// foreach($aProfils as $key=>$val) {
	 * @author	
	 **/
	
	public function get_aprofil() {
		# Tableau des profils
		return array(
			PROFIL_ADMIN => L_PROFIL_ADMIN,
			PROFIL_MANAGER => L_PROFIL_MANAGER,
			PROFIL_MODERATOR => L_PROFIL_MODERATOR,
			PROFIL_EDITOR => L_PROFIL_EDITOR,
			PROFIL_WRITER => L_PROFIL_WRITER
		);
		
	}
	
	# define admin right list for sliders list
	public function get_adminright_list() {
		return "view create modify delete";
	}
	
	# define admin right list for slider content
	public function get_adminrightcontent_list() {
		return "create modify delete";
	}
	
	public function get_tableuserlevel($param='profiladmin') {
		$s='';
		$aProfils = $this->get_aprofil();
		foreach($aProfils as $key=>$val) {
			$sright = $this->getParam($param.$key);
			$aright = explode (" ", $sright);
			foreach($aright as $key2=>$val2) {
				if ($val2=="view"){
					$s.=$key.',';
					break;	
				}
			}
		}
		return substr ($s, 0, -1);
	}
	
	public function get_rightCMDlevel($param='profiladmin') {
		$s='';
		$aProfils = $this->get_aprofil();
		foreach($aProfils as $key=>$val) {
			$sright = $this->getParam($param.$key);
			$aright = explode (" ", $sright);
			$create='0';
			$modify='0';
			$delete='0';
			foreach($aright as $key2=>$val2) {
				if ($val2=="create"){
					$create='1';
				}
				if ($val2=="modify"){
					$modify='1';
				}
				if ($val2=="delete"){
					$delete='1';
				}
			}
			$s.=$key.':'.$create.$modify.$delete.',';
		}
		return substr ($s, 0, -1);
		//return '3:010,4:010';
	}
	
	public function write_table() {
		$xml =$this->get_table_spxdatas();
		$path = PLX_PLUGINS.'spxwresponsiveslides/spxdatas/table/table.php';
		$bwrite = plxUtils::write($xml,$path);
		/*
		if($bwrite) {
			return plxMsg::Info(L_SAVE_SUCCESSFUL);		
		} else {
			return plxMsg::Error(L_SAVE_ERR.' '.PLX_ROOT.$this->aConf['categories']);
		}
		*/
	}
	
	# get html content for slider
	public function getResponsiveslidesID($o) {
		$filter = 'spxwresponsiveslides_id='.$o["id"];
		return $this->get_slider_display($filter,$o);
	}
	
	# get html content for slider
	public function getResponsiveslidesTitle($o) {
		$filter = 'title='.$o["title"];
		return $this->get_slider_display($filter,$o);
	}
	public function get_slider_display($filter,$o) {
		$uniqid = uniqid();
		$colortheme = "spxwresponsiveslides-".$o["colortheme"];
		$pos = $o["pos"];
		
		switch ($pos) {
			case "left":
				$posstyle="float: left;";
				break;
			case "right":
				$posstyle="float: right;";
				break;
			case "center":
				$posstyle="display: block; margin-left: auto; margin-right: auto;";
				break;
			
		}
		
		$style_container= 'width:'.$o["width"].';';
		$style_container.= $posstyle;
		
		$s='';
		$s.='<div class="spxwresponsiveslides '.$colortheme.'" style="'.$style_container.'">';
				//$s.='<ul id="rslides-'.$uniqid.'" class="rslides">';
					$s.= $this->get_slider_request($uniqid,$filter,$o) ;
				
				//$s.='</ul>';
			$s.='</div>';
		$s.='
		
		<script type="text/javascript">
		
				jQuery(function($){
					
					$("#rslides-'.$uniqid.'").responsiveSlides({
					
					 auto: '.$o["auto"].',             // Boolean: Animate automatically, true or false
					  speed: '.$o["speed"].',            // Integer: Speed of the transition, in milliseconds
					  timeout: '.$o["timeout"].',          // Integer: Time between slide transitions, in milliseconds
					  pager: '.$o["pager"].',           // Boolean: Show pager, true or false
					  nav: '.$o["nav"].',             // Boolean: Show navigation, true or false
					  random: '.$o["random"].',          // Boolean: Randomize the order of the slides, true or false
					  pause: '.$o["pause"].',           // Boolean: Pause on hover, true or false
					  pauseControls: '.$o["pauseControls"].',    // Boolean: Pause when hovering controls, true or false
					  prevText: "'.$o["prevText"].'",   // String: Text for the "previous" button
					  nextText: "'.$o["nextText"].'",       // String: Text for the "next" button
					  maxwidth: "'.$o["maxwidth"].'",           // Integer: Max-width of the slideshow, in pixels
					  navContainer: "'.$o["navContainer"].'",       // Selector: Where controls should be appended to, default is after the "ul"
					  manualControls: "#'.$uniqid.'-pager",     // Selector: Declare custom pager navigation
					  namespace: "'.$o["namespace"].'",   // String: Change the default namespace used
					
					
					
					});
			   	})
		</script>
		
		
		';
		
		
		return $s;
	}
	
	public function get_slider_request($uniqid,$filter,$atts) {
		$plxMotor = plxMotor::getInstance();
		$IMAGEPATH = isset($plxMotor->aConf['medias']) ? plxUtils::getRacine().$plxMotor->aConf['medias'] : plxUtils::getRacine().$plxMotor->aConf['images'];	
		$IMAGEPATH2 = isset($plxMotor->aConf['medias']) ? $plxMotor->aConf['medias'] : $plxMotor->aConf['images'];		
		
		
		
		$o= array();
		$o["table"]="spxwresponsiveslides";
		$o["filter"]=$filter;
		
		$tmp = $plxMotor->plxPlugins->aPlugins["spxdatas"];
		
		$o["out"]="array";
		$tmp2 = $tmp->getData($o);
		
		$s='<ul id="rslides-'.$uniqid.'" class="rslides">';
		foreach($tmp2[0]["slider_content"] as $key=>$val) {
			$img = $IMAGEPATH.$val["image"];
			$s.='<li>';
						
			$s.='<img src="'.$img.'" alt="">';
			if ($atts ["displaytitle"]=='true'){
				if ($val["title"]!="")
					$s.='<p class="caption">'.$val["title"].'</p>';
			}
						
			$s.='</li>';
		}
		$s.='</ul>';
		
		$imgsize = '50';
		$IMAGERESIZE = PLX_PLUGINS.$this->spxname."/imageResize2.php?w=".$imgsize."&h=".$imgsize."&transform=reducecrop&color=0";
		
		if ($atts["displaythumbs"]=='true'){
			$s.='<ul id="'.$uniqid.'-pager" class="rslides_tabs" >';
				foreach($tmp2[0]["slider_content"] as $key=>$val) {
					$img = $IMAGEPATH2.$val["image"];
					$imgsrc = $IMAGERESIZE."&file=../../".$img; 
					$s.='<li><a href="#"><img src="'.$imgsrc.'" alt=""></a></li>';
				}
			$s.='</ul>';
		}
		
		
		
		return $s;
		
		
		
	}
		
	public function get_slider_requestOLD($filter) {
		$plxMotor = plxMotor::getInstance();
		$IMAGEPATH = isset($plxMotor->aConf['medias']) ? plxUtils::getRacine().$plxMotor->aConf['medias'] : plxUtils::getRacine().$plxMotor->aConf['images'];	
		
		
		
		//echo ("test2=".$IMAGEPATH);
		
		$s='<li>';
						
			$s.='<img src="'.$IMAGEPATH.'#image" alt="">';
			$s.='<p class="caption">This is a caption</p>';
						
		$s.='</li>';
		
		
		$o= array();
		$o["table"]="spxwresponsiveslides";
		$o["out"]="html";
		
		$o["format"]='#slider_content';
		$o["filter"]=$filter;
		$o["subtable_format"]["slider_content"]=$s;
		$tmp = $plxMotor->plxPlugins->aPlugins["spxdatas"];
		return $tmp->getData($o);
		
	}
	
	# define admin right list
	public function get_table_spxdatas() {
		$dataformat='';
		if ($this->getParam('dataformat') =="json")
			$dataformat='dataformat="json"';
		$s='';
		$s.='<table name="spxwresponsiveslides" maxparam="2" groupe="spxwresponsiveslides" '.$dataformat.' tableuserlevel="'.$this->get_tableuserlevel().'" rightCMDlevel="'.$this->get_rightCMDlevel().'" >';
		$s.='<description><![CDATA[<p>List of sliders</p>]]></description>';
			$s.='<column>';
					$s.='<parameter  name="title" type="cdata" option="textinput/30/100" ></parameter>';
					$s.='<parameter  name="slider_content" type="cdata" option="subtable/spxwresponsiveslide" ></parameter>';
			$s.='</column>';
		$s.='</table>';
		
		
		$s.='<table name="spxwresponsiveslide" maxparam="2" groupe="spxwresponsiveslides" type="subtable" order="true" '.$dataformat.' rightCMDlevel="'.$this->get_rightCMDlevel('profiladmincontent').'" >';
		$s.='<description><![CDATA[<p>Your slider</p>]]></description>';
			$s.='<column>';
				
				$s.='<parameter  name="title" type="cdata" option="textinput/30/100" ></parameter>';
				$s.='<parameter  name="image" type="cdata" option="image" ></parameter>';
				
			$s.='</column>';
		$s.='</table>';
		return $s;
	}
	
	# getloc call by spxdatas
	public function get_loc($mylang) {
		$filename = PLX_PLUGINS.$this->spxname.'/spxdatas/table/table_loc/'.$mylang.'/admin.php';
		$LANG = array();
		if(is_file($filename)) {
			include($filename);
		}
		return $LANG;
	}
	
	# getdefaultloc use by config traduction
	public function get_loc_default($mylang) {
		$filename = PLX_PLUGINS.$this->spxname.'/spxdatas/table/table_loc/'.$mylang.'/admin_default.php';
		
		$LANG = array();
		if(is_file($filename)) {
			include($filename);
		}
		return $LANG;
		
	}
	
	# record loc for spxdatas
	public function set_loc($mylang) {
		$atraddefault = $this->get_loc_default($mylang);
		$LANG="LANG";
		$out="<?php
		
					$$LANG = array(";
		foreach($atraddefault as $key=>$val) {
			
			$code = 'admin_loc_'.$trad.'_'.$key;
			$check = $this->getParam($code);
			if ($check=="-") {
				$loc="";
			}else if ($check=="") {
				$loc=$val;
			}else{
				$loc=$check;
			}
			$loc = str_replace("'", "\'", $loc);
			
			$out.="'".$key."'			=> '".$loc."',";
		}
		$out.="	
					);
					?>";
		$fileloc = PLX_PLUGINS.$this->spxname.'/spxdatas/table/table_loc/'.$mylang.'/admin.php';
		plxUtils::write($out,$fileloc);
	}

}

?>